<ui:composition xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:g="http://www.ihe.net/gazelle" xmlns:a4j="http://richfaces.org/a4j"
                xmlns:h="http://java.sun.com/jsf/html" xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:rich="http://richfaces.org/rich" xmlns:f="http://java.sun.com/jsf/core"
                xmlns="http://www.w3.org/1999/xhtml" template="/layout/template.xhtml">
    <ui:define name="body">
        <h:form id="gForm"><h1>#{messages['gazelle.pam.AssigningAuthorities']}</h1>
            <a4j:queue requestDelay="300" ignoreDupResponses="true"/>
            <h:inputHidden id="filterUrlParameters" name="filterUrlParameters"
                           value="#{patientManager.filter.urlParameters}"/>
            <script>
                updateUrl("gForm:filterUrlParameters");
                jq162("#gForm\\:filterUrlParameters").bind('change',
                    function () {
                        updateUrl("gForm:filterUrlParameters");
                    });

            </script>
            <s:decorate template="/layout/panels/_panel_title_footer.xhtml"
                        rendered="#{assigningAuthorityManager.hierarchicDesignator == null}">
                <ui:define name="panel_title">#{messages['net.ihe.gazelle.patientmanager.AssigningAuthorities']}</ui:define>
                #{dataTableStateHolder.setAscendingOn('namespaceID')}
                <s:decorate template="/layout/form/_checkbox.xhtml">
                    <h:selectBooleanCheckbox value="#{assigningAuthorityManager.displayOnlyForTool}">
                        <a4j:ajax event="change" render="gForm"/>
                    </h:selectBooleanCheckbox>
                    #{messages['net.ihe.gazelle.patientmanager.HideExternalAssigningAuthorities']}
                </s:decorate>
                <s:decorate template="/layout/form/_checkbox.xhtml"
                            rendered="#{assigningAuthorityManager.isCatFeatureEnabled()}">
                    <h:selectBooleanCheckbox value="#{assigningAuthorityManager.displayOnlyForCat}">
                        <a4j:ajax event="change" render="gForm"/>
                    </h:selectBooleanCheckbox>
                    <h:outputText value="#{messages['gazelle.PAMSimulator.DisplayOnlyAssigningAuthoritiesForConnectathon']}"/>
                </s:decorate>
                <rich:dataTable value="#{assigningAuthorityManager.getHierarchicDesignators()}"
                                render="ds" id="aatable" var="aa" rows="#{dataScrollerMemory.numberOfResultsPerPage}">
                    <g:column sortBy="#{'namespaceID'}" sortOrder="#{dataTableStateHolder.sortOrders['namespaceID']}"
                              filterBy="#{'namespaceID'}" filterEvent="onkeyup">
                        <ui:define name="header">#{messages['gazelle.patientmanager.NamespaceID']}</ui:define>
                        <h:outputText value="#{aa.namespaceID}"/>
                    </g:column>
                    <g:column sortBy="#{'universalID'}" sortOrder="#{dataTableStateHolder.sortOrders['universalID']}"
                              filterBy="#{'universalID'}" filterEvent="onkeyup">
                        <ui:define name="header">#{messages['gazelle.patientmanager.UniversalID']}</ui:define>
                        <h:outputText value="#{aa.universalID}"/>
                    </g:column>
                    <g:column sortBy="#{'universalIDType'}"
                              sortOrder="#{dataTableStateHolder.sortOrders['universalIDType']}"
                              filterBy="#{'universalIDType'}" filterEvent="onkeyup">
                        <ui:define name="header">#{messages['net.ihe.gazelle.patientmanager.UniversalIDType']}</ui:define>
                        <h:outputText value="#{aa.universalIDType}"/>
                    </g:column>
                    <g:column>
                        <ui:define name="header">#{messages['net.ihe.gazelle.patientmanager.Type']}</ui:define>
                        <h:outputText value="#{aa.type}"/>
                    </g:column>
                    <g:column>
                        <ui:define name="header">#{messages['net.ihe.gazelle.patientmanager.Prefix']}</ui:define>
                        <h:outputText value="#{aa.prefix}"/>
                    </g:column>
                    <g:column>
                        <ui:define name="header">#{messages['gazelle.hl7.Usage']}</ui:define>
                        <h:outputText value="#{aa.usage.friendlyName}"/>
                    </g:column>
                    <g:column>
                        <ui:define name="header">#{messages['net.ihe.gazelle.patientmanager.OwnedByTool']}</ui:define>
                        <s:decorate template="/layout/form/_checkbox.xhtml">
                            <h:selectBooleanCheckbox value="#{aa.toolAssigningAuthority}"
                                                     disabled="true"/>
                            <h:outputText value="#{messages['gazelle.PAMSimulator.Connectathon']}" styleClass="gzl-label gzl-label-blue"
                                          rendered="#{aa.catUsage}"/>
                        </s:decorate>
                    </g:column>
                    <g:column>
                        <ui:define name="header">#{messages['net.ihe.gazelle.patientmanager.Default']}</ui:define>
                        <s:decorate template="/layout/form/_checkbox.xhtml">
                            <h:selectBooleanCheckbox value="#{aa.defaultAssigningAuthority}"
                                                     disabled="true"/>
                        </s:decorate>
                    </g:column>
                    <g:column>
                        <ui:define name="header">#{messages['net.ihe.gazelle.patgen.Actions']}</ui:define>
                        <a4j:commandLink actionListener="#{assigningAuthorityManager.editHierarchicDesignator(aa)}"
                                         render="gForm" title="#{messages['users.Edit']}">
                            <s:span styleClass="gzl-icon-pencil"/>
                        </a4j:commandLink>
                        <a4j:commandLink actionListener="#{assigningAuthorityManager.deactivateAssigningAuthority(aa)}"
                                         render="gForm" title="#{messages['net.ihe.gazelle.patientmanager.Deactivate']}"
                                         rendered="#{aa.defaultAssigningAuthority or aa.toolAssigningAuthority}">
                            <s:span styleClass="gzl-icon-times-circle"/>
                        </a4j:commandLink>

                    </g:column>
                    <f:facet name="footer">
                        <ui:include src="/util/datatableFooter.xhtml">
                            <ui:param name="dataScrollerId" value="ds"/>
                            <ui:param name="dataTableId" value="aatable"/>
                        </ui:include>
                    </f:facet>
                </rich:dataTable>
                <ui:define name="panel_footer">
                    <a4j:commandButton value="#{messages['net.ihe.gazelle.patientmanager.CreateAnAssigningAuthority']}"
                                       actionListener="#{assigningAuthorityManager.createNewHierarchicDesignator()}"
                                       render="gForm" styleClass="gzl-btn-green"/>
                </ui:define>
            </s:decorate>
            <s:decorate template="/layout/panels/_panel_title.xhtml"
                        rendered="#{assigningAuthorityManager.hierarchicDesignator == null}">
                <ui:define name="panel_title">#{messages['net.ihe.gazelle.patientmanager.DefaultAssigningAuthorities']}</ui:define>
                <h:outputText value="#{messages['net.ihe.gazelle.patientmanager.SelectBelowTheDefaultAssigningAuthoritiesToUseDe']}"
                              styleClass="help-block"/>
                <div class="form-horizontal col-md-8 col-md-offset-2">
                    <ui:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.patientmanager.AccountNumbers']}</ui:define>
                        <ui:param name="id" value="anAA"/>
                        <h:selectOneMenu value="#{assigningAuthorityManager.appAccountNumber.value}"
                                         styleClass="form-control" id="anAA">
                            <f:selectItems value="#{assigningAuthorityManager.getAssigningAuthoritiesForUsage('AN')}"/>
                            <a4j:ajax event="change" listener="#{assigningAuthorityManager.updateForAccount()}"
                                      execute="@this"/>
                        </h:selectOneMenu>
                    </ui:decorate>
                    <ui:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.PatientManager.PatientIdentifiers']}</ui:define>
                        <ui:param name="id" value="pidAA"/>
                        <h:selectOneMenu value="#{assigningAuthorityManager.appPatientId.value}"
                                         styleClass="form-control" id="pidAA">
                            <f:selectItems value="#{assigningAuthorityManager.getAssigningAuthoritiesForUsage('PI')}"/>
                            <a4j:ajax event="change" listener="#{assigningAuthorityManager.updateForPatient()}"
                                      execute="@this"/>
                        </h:selectOneMenu>
                    </ui:decorate>
                    <ui:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.patientmanager.VisitNumbers']}</ui:define>
                        <ui:param name="id" value="vnAA"/>
                        <h:selectOneMenu value="#{assigningAuthorityManager.appVisitNumber.value}"
                                         styleClass="form-control" id="vnAA">
                            <f:selectItems value="#{assigningAuthorityManager.getAssigningAuthoritiesForUsage('VN')}"/>
                            <a4j:ajax event="change" listener="#{assigningAuthorityManager.updateForVisit()}"
                                      execute="@this"/>
                        </h:selectOneMenu>
                    </ui:decorate>
                    <ui:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.patientmanager.MovementIdentifiers']}</ui:define>
                        <ui:param name="id" value="movAA"/>
                        <h:selectOneMenu value="#{assigningAuthorityManager.appMovementNumber.value}"
                                         styleClass="form-control" id="movAA">
                            <f:selectItems value="#{assigningAuthorityManager.getAssigningAuthoritiesForUsage('MOV')}"/>
                            <a4j:ajax event="change" listener="#{assigningAuthorityManager.updateForMovement()}"
                                      execute="@this"/>
                        </h:selectOneMenu>
                        <h:outputText value="#{messages['net.ihe.gazelle.patientmanager.UsedInITI31ForHistoricMovementOption']}"
                                      styleClass="help-block"/>
                    </ui:decorate>
                </div>
            </s:decorate>
            <s:decorate template="/layout/panels/_panel_title_footer.xhtml" id="aaedit"
                        rendered="#{assigningAuthorityManager.hierarchicDesignator != null}">
                <ui:define name="panel_title">#{messages['net.ihe.gazelle.patientmanager.AssigningAuthorityDetails']}</ui:define>
                <div class="form-horizontal col-md-8 col-md-offset-2">
                    <s:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml">
                        <ui:define name="label">#{messages['gazelle.patientmanager.NamespaceID']}</ui:define>
                        <ui:param name="id" value="ns"/>
                        <h:inputText value="#{assigningAuthorityManager.hierarchicDesignator.namespaceID}"
                                     styleClass="form-control" id="ns" size="80"/>
                    </s:decorate>
                    <s:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml">
                        <ui:define name="label">#{messages['gazelle.patientmanager.UniversalID']}</ui:define>
                        <ui:param name="id" value="uid"/>
                        <h:inputText value="#{assigningAuthorityManager.hierarchicDesignator.universalID}"
                                     styleClass="form-control" id="uid" size="80"/>
                    </s:decorate>
                    <s:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.patientmanager.UniversalIDType']}</ui:define>
                        <ui:param name="id" value="uidtype"/>
                        <h:inputText value="#{assigningAuthorityManager.hierarchicDesignator.universalIDType}"
                                     styleClass="form-control" id="uidtype" size="80"/>
                    </s:decorate>
                    <s:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.patientmanager.IdentifierTypeCode']}</ui:define>
                        <ui:param name="id" value="type"/>
                        <h:inputText value="#{assigningAuthorityManager.hierarchicDesignator.type}"
                                     styleClass="form-control" id="type" size="80"/>
                    </s:decorate>
                    <s:decorate template="/layout/form/_form_checkbox_horizontal_3-9.xhtml">
                        <ui:param name="id" value="used"/>
                        <h:selectBooleanCheckbox
                                value="#{assigningAuthorityManager.hierarchicDesignator.toolAssigningAuthority}"
                                id="used">
                            <a4j:ajax event="change" render="aaedit"/>
                        </h:selectBooleanCheckbox>
                        #{messages['net.ihe.gazelle.patientmanager.OwnedByTheTool']}
                    </s:decorate>
                    <s:decorate template="/layout/form/_form_checkbox_horizontal_3-9.xhtml"
                                rendered="#{assigningAuthorityManager.hierarchicDesignator.toolAssigningAuthority}">
                        <ui:param name="id" value="cat"/>
                        <h:selectBooleanCheckbox
                                value="#{assigningAuthorityManager.hierarchicDesignator.catUsage}"
                                id="cat">
                            <a4j:ajax event="change" render="cat"/>
                        </h:selectBooleanCheckbox>
                        <h:outputText value="#{messages['gazelle.PAMSimulator.ShallOnlyBeUsedForConnectathonsDemographics']}"/>
                    </s:decorate>
                    <s:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml" id="usageDec"
                                rendered="#{assigningAuthorityManager.hierarchicDesignator.toolAssigningAuthority}">
                        <ui:define name="label">#{messages['gazelle.hl7.Usage']}</ui:define>
                        <ui:param name="id" value="usage"/>
                        <h:selectOneMenu value="#{assigningAuthorityManager.hierarchicDesignator.usage}"
                                         styleClass="form-control" id="usage" required="true">
                            <f:selectItems value="#{assigningAuthorityManager.getAvailableUsages()}"/>
                            <a4j:ajax event="change" render="usageDec"/>
                        </h:selectOneMenu>
                    </s:decorate>
                    <s:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml"
                                rendered="#{assigningAuthorityManager.hierarchicDesignator.toolAssigningAuthority}">
                        <ui:define name="label">#{messages['net.ihe.gazelle.patientmanager.Prefix']}</ui:define>
                        <ui:param name="id" value="prefix"/>
                        <h:inputText value="#{assigningAuthorityManager.hierarchicDesignator.prefix}"
                                     styleClass="form-control" id="prefix" size="80"/>
                    </s:decorate>
                    <s:decorate template="/layout/form/_form_checkbox_horizontal_3-9.xhtml"
                                rendered="#{assigningAuthorityManager.hierarchicDesignator.toolAssigningAuthority}">
                        <ui:param name="id" value="isdefault"/>
                        <h:selectBooleanCheckbox
                                value="#{assigningAuthorityManager.hierarchicDesignator.defaultAssigningAuthority}"
                                id="isdefault"/>
                        #{messages['net.ihe.gazelle.patientmanager.DefaultAssigningAuthority']}
                    </s:decorate>
                    <s:decorate template="/layout/form/_form_field_horizontal_3-9.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.patientmanager.Index']}</ui:define>
                        <ui:param name="id" value="index"/>
                        <rich:inputNumberSpinner value="#{assigningAuthorityManager.hierarchicDesignator.index}" id="index" maxValue="10000"
                                                 minValue="0" rendered="#{assigningAuthorityManager.hierarchicDesignator.toolAssigningAuthority}"/>
                        <h:outputText value="#{messages['net.ihe.gazelle.patientmanager.External']}"
                                      rendered="#{not assigningAuthorityManager.hierarchicDesignator.toolAssigningAuthority}"/>
                        <a4j:commandButton actionListener="#{assigningAuthorityManager.resetIndex()}" render="aaEdit"
                                           styleClass="gzl-btn-orange" value="#{messages['gazelle.PAMSimulator.ResetIndex']}"
                                           rendered="#{assigningAuthorityManager.hierarchicDesignator.toolAssigningAuthority}"/>
                    </s:decorate>
                </div>
                <ui:define name="panel_footer">
                    <a4j:commandButton value="#{messages['gazelle.HL7Common.Back']}"
                                       actionListener="#{assigningAuthorityManager.setHierarchicDesignator(null)}"
                                       byPassUpdates="true"
                                       render="gForm" styleClass="gzl-btn"/>
                    <a4j:commandButton value="#{messages['gazelle.HL7Common.Save']}"
                                       actionListener="#{assigningAuthorityManager.save()}"
                                       render="gForm" styleClass="gzl-btn-green"/>
                </ui:define>
            </s:decorate>
        </h:form>
    </ui:define>
</ui:composition>